function [U]=HHWeuCallII_RBFPUM(tol)

% Problem parameters 
K0 = 100;
K = 1;
S = [75,100,125];
T = 10;
V = 0.04;
R = 0.1;
kappa = 0.5;
eta = 0.04;
sig1 = 1;
sig2 = 0.09;
rho12 = -0.9;
rho13 = 0;
rho23 = 0;
a = 0.08;
b = 0.1;
%beta = 0.5;
payoff = @(S,K,r,t) max(S-K*exp(-r*t),0); % Payoff

phi = 'mq'; % RBF type
op = '0';
delta = 0.2;

% Domain, partly following in 't Hout
xmin = 0;
xmax = 4*K;           
vmin = 0.005;
vmax = 2;
rmin = -1;
rmax = 1;

%npx = 5 ep =3 1.4
% npx=7  3 0.94
% npx = 8 3 0.8 3.5 0.77
% npx = 9 6 1.16

% Number of discretization points determined by the S direction
%ep = 3; % Shape pararameter
%npx = 7;
if (tol>1.4)
  npx = 5;
  ep=3;
elseif (tol>0.94)
  npx=7;
  ep=3;
else
  npx = 8;
  ep=3.5;
end

Nx = 20/8*npx; Nx = 2*floor(Nx/2)+1; % Odd number of points
Hx = (xmax-xmin)/npx;
npv = ceil((vmax-vmin)/Hx);
npr = ceil((rmax-rmin)/Hx);
Nv = max(5,Nx/npx*npv);  Nv = 2*floor(Nv/2)+1;
Nr = max(5,Nx/npx*npr);  Nr = 2*floor(Nr/2)+1;

M = 40; % # Time steps

% Generate computational nodes
x = linspace(xmin,xmax,Nx);
v = linspace(vmin,vmax,Nv);
r = linspace(rmin,rmax,Nr);
[xx,vv,rr] = meshgrid(x,v,r);
xc = [xx(:),vv(:),rr(:)];

% BC index mask
tind = zeros(size(xx));
tind(:,1,:) = 1;
tind(:,end,:) = 2;
tind(1,2:end-1,:) = 3;
tind(end,2:end-1,:) = 4;
tind(:,2:end-1,1) = 5;
tind(:,2:end-1,end) = 6;

% Generate the patches
Hx = xmax/npx;
x = xmin+Hx/2:Hx:xmax-Hx/2;
Hv = (vmax-vmin)/npv;
v = vmin+Hv/2:Hv:vmax-Hv/2;
Hr = (rmax-rmin)/npr;
z = rmin+Hr/2:Hr:rmax-Hr/2;

Rad = sqrt(3)*max([Hx,Hv,Hr])/2*(1+delta);

[xm,ym,zm] = meshgrid(x,v,z); % centers of partitions
xm = [xm(:) ym(:) zm(:)];
Np = length(xm); % number of partitions

%tic
U = HHWpum(S,K0,T,R,V,kappa,eta,sig1,sig2,rho12,rho13,rho23,a,b,payoff,phi,ep,xc,M,xm,Rad,op,tind);
U = U';
%toc
%Uref = [35.437896876285350 54.728065308229503 75.397596834993621]


%err=abs(U-Uref)














