%
% This is a reasonable result, but it would be relevant to try also with
% some clustering around K. This could be just tested.
%
function [Ue] = SABReuCallII_RBFPUM(tol)
%function err = SABReuCallI_RBFPUM(tol)
%
% Given problem parameters and functions
%  
warning off  
T = 10; % Time to maturity
r = 0;
S = 0.07;
V = 0.4;
alpha = 0.8;
beta = 0.5;
rho = -0.6;
delta_i = -1:1:1;
KK = S*exp(0.1*sqrt(T)*delta_i); % Three different strike values
payoff = @(S,K,r,t) max(S*exp(r*t)-K*exp(-r*t),0); % Payoff function
%
% Method parameters that we keep fixed
%
phi = 'mq'; % RBF type
delta = 0.2;
op = '0';
%
% Parameters that should be chosen as a function of tol
% Points aligned with npx, maybe only do patch refinement.
% Test, and then plot accuracy and time to decide what makes sense.
% 0.0053 0.0060 0.0090
% The good choice now is npx = 4 and Nx = 16; An equal number of points
% within each patch, but not aligned the same. This can be tested too.
% x x x x x x x x x x x x x x x x
% |      |       |       |      |
% Domain boundaries
xmin = 0; % Lower domain boundary in stock
xmax = 4*max(KK);1.6;%1.226;%2*K; % Upper domain boundary in stock
ymin = 0.01; % Lower domain boundary in vol
ymax = 1; % Upper domain boundary in vol
ymin = 0.01;
ymax = 0.7;

npx = max(1,round(-13*log10(tol)-36)); %max(1,round(-log10(tol)*2-1))
ep = 1.5*npx+0.3; 
       %pause
Nx = 6*npx; % # Space points in stock direction
Hx = (xmax-xmin)/npx;
sc = (ymax-ymin)/(xmax-xmin);
npy = ceil((ymax-ymin)/Hx);
Ny = Nx/npx*npy;

M = npx*T; % # Time steps

% Err = 0.0031 nx = 4, epp = 0.8, M = 20, xmax = 1.226, 

% Generate computational nodes
ell=2;
x = linspace(xmin,xmax,Nx);
y = linspace(ymin,ymax,Ny);
[xx,yy] = meshgrid(x,y);

% Here the boundary conditions are swapped. Gave trouble in the code.
xtype = zeros(size(yy));
xtype(1,:) = 1; % S-boundary
xtype(end,:) = 2; % S-boundary
xtype(2:end-1,1) = 3; % V-boundary
xtype(2:end-1,end) = 4; % V-boundary
xtype = xtype(:);
xc = [xx(:),yy(:)];

% Generate patches
Hx = (xmax-xmin)/npx;
x = xmin+Hx/2:Hx:xmax-Hx/2;
Hy = (ymax-ymin)/npy;
y = ymin+Hy/2:Hy:ymax-Hy/2;
[xm,ym] = meshgrid(x,y); % centers of partitions
xm = [xm(:) ym(:)];
Np = length(xm); % number of partitions
R = sqrt(2)*max([Hx,Hy])/2*(1+delta);

%tic
%Ue =
%SABRpum(S,KK,T,r,V,rho,alpha,beta,payoff,phi,ep,xc,M,npx,npy,delta,op,xtype,Nx,Ny,xx,yy);
Ue = SABRpum(S,KK,T,r,V,rho,alpha,beta,payoff,phi,ep,xc,M,xm,R,op,xtype);
%time(ii)=toc

%Uref = [0.052642175810679 0.046764602249588 0.039454092204406];
%err = abs(Uref-Ue)
%maxerr(ii)=max((err))
%end
%loglog(maxerr,time,'k')








