%
% This is a reasonable result, but it would be relevant to try also with
% some clustering around K. This could be just tested.
%
function [Ue] = SABReuCallI_RBFPUM(tol)
%function err = SABReuCallI_RBFPUM(tol)
%
% Given problem parameters and functions
%
warning off  
T = 2; % Time to maturity
r = 0;
S = 0.5;
V = 0.5;
alpha = 0.4;
beta = 0.5;
rho = 0;
delta_i = -1:1:1;
KK = S*exp(0.1*sqrt(T)*delta_i); % Three different strike values
payoff = @(S,K,r,t) max(S*exp(r*t)-K*exp(-r*t),0); % Payoff function
%
% Method parameters that we keep fixed
%
phi = 'mq'; % RBF type
delta = 0.2;
op = '0';
%
% Parameters that should be chosen as a function of tol
% Points aligned with npx, maybe only do patch refinement.
% Test, and then plot accuracy and time to decide what makes sense.
% 0.0053 0.0060 0.0090
% The good choice now is npx = 4 and Nx = 16; An equal number of points
% within each patch, but not aligned the same. This can be tested too.
% x x x x x x x x x x x x x x x x
% |      |       |       |      |
% Domain boundaries
xmin = 0; % Lower domain boundary in stock
xmax = 4*max(KK);1.6;%1.226;%2*K; % Upper domain boundary in stock
ymin = 0.01; % Lower domain boundary in vol
ymax = 1; % Upper domain boundary in vol
ymin = 0.01;
ymax = 0.6;

%npvec=2:12;
%xvec = 0.8:0.2:2;

%for ii=1:length(npvec)
%ii=1; 
  %xmax = xvec(ii);
  %npx = npvec(ii)

% maxerr = 1.7e-3, ep=1.5 Nx=24, npx=4, xmax=1.6 (longer time)
% maxerr = 2e-3, ep=1.4 Nx=24, npx=6, xmax=1.6, M=12
% maxerr = 2e-3, ep=1.0 Nx=20, npx=5, xmax=1.6, M=12
% maxerr = 2e-3, ep=1.2 Nx=16, npx=4, xmax=1.6, M=10
% maxerr = 1.2e-2, ep=1 Nx=12, npx=3, xmax=1.6, M=5;
% maxerr = 2.2e-3, ep=1.8 Nx=18, npx=3, xmax=1.6, M=15;
% maxerr = 2.2e-3, ep=0.8 Nx=8, npx=2, xmax=1.6, M=4
% maxerr = 2.7e-3, ep=1.8 Nx=12, npx=2, xmax=1.6, M=15
% 6.4e-4 Nx=48; npx=12 xmax=4K ymin=0.01, ymax=0.6, ep=2; M=10
% 6.4e-4 Nx=40; npx=10 xmax=4K ymin=0.01, ymax=0.6, ep=1.2; M=10
% 4.0e-4 Nx=32, npx=8 -"-
% 3.5 e-3 nx=24, npx=6

% All these solutions converge with a bias.
% Is it due to the boundary condition?
% Are odd numbers of partitions better?
%ep = 0.8; % Shape parameter %7.9
          %a*npx + b
          %npx = 12; % # Partitions in stock direction
                    %ep = 0.12*npx+0.56
% 1e-2 at p=3 1e-3 at p=5 1e-4 at p=7, but not very exact

npx = max(1,round(-log10(tol)*2-1));
ep = 0.20*npx+0.5; %0.15
Nx = 6*npx; % # Space points in stock direction
Hx = (xmax-xmin)/npx;
sc = (ymax-ymin)/(xmax-xmin);
npy = ceil((ymax-ymin)/Hx);
Ny = Nx/npx*npy;

M = npx*2; % # Time steps

% Err = 0.0031 nx = 4, epp = 0.8, M = 20, xmax = 1.226, 

% Generate computational nodes
x = linspace(xmin,xmax,Nx);
y = linspace(ymin,ymax,Ny);
[xx,yy] = meshgrid(x,y);

% Here the boundary conditions are swapped. Gave trouble in the code.
xtype = zeros(size(yy));
xtype(1,:) = 1; % V-boundary
xtype(end,:) = 2; % V-boundary
xtype(2:end-1,1) = 3; % S-boundary
xtype(2:end-1,end) = 4; % Sx-boundary
xtype = xtype(:);
xc = [xx(:),yy(:)];

% Generate patches
Hx = (xmax-xmin)/npx;
x = xmin+Hx/2:Hx:xmax-Hx/2;
Hy = (ymax-ymin)/npy;
y = ymin+Hy/2:Hy:ymax-Hy/2;
[xm,ym] = meshgrid(x,y); % centers of partitions
xm = [xm(:) ym(:)];
Np = length(xm); % number of partitions
R = sqrt(2)*max([Hx,Hy])/2*(1+delta);

%tic
%Ue =
%SABRpum(S,KK,T,r,V,rho,alpha,beta,payoff,phi,ep,xc,M,npx,npy,delta,op,xtype,Nx,Ny,xx,yy);
Ue = SABRpum(S,KK,T,r,V,rho,alpha,beta,payoff,phi,ep,xc,M,xm,R,op,xtype);
%time(ii)=toc

%Uref = [0.221384673705373, 0.193836677935087, 0.166240945644079];
%err = abs(Uref-Ue)
%maxerr(ii)=max((err))
%end
%loglog(maxerr,time,'k')








